=== debian/changelog ===
mgmt (0.0.26.git.2024.10.25.85e1d6c0e8-4) unstable; urgency=medium

  * Move systemd service file to /usr (Closes:# 1102451).

 -- Thomas Goirand <zigo@debian.org>  Wed, 09 Apr 2025 13:22:29 +0200

mgmt (0.0.26.git.2024.10.25.85e1d6c0e8-3) unstable; urgency=medium

  * Re-upload source-only.

 -- Thomas Goirand <zigo@debian.org>  Sat, 05 Apr 2025 18:18:41 +0200

mgmt (0.0.26.git.2024.10.25.85e1d6c0e8-2) unstable; urgency=medium

  * Fix d/copyright according to suggestion from FTP team.

 -- Thomas Goirand <zigo@debian.org>  Fri, 04 Apr 2025 08:35:03 +0200

mgmt (0.0.26.git.2024.10.25.85e1d6c0e8-1) unstable; urgency=medium

  * Initial release. (Closes: #1100571)

 -- Thomas Goirand <zigo@debian.org>  Thu, 29 Sep 2022 13:19:14 +0200
