=== debian/control ===
Source: mgmt
Section: admin
Priority: optional
Maintainer: Thomas Goirand <zigo@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dh-golang,
 go-bindata,
 golang-any,
 golang-etcd-server-dev (>= 3.5.5),
 golang-github-alexflint-go-arg-dev,
 golang-github-ashcrow-osrelease-dev,
 golang-github-blynn-nex-dev,
 golang-github-containerd-containerd-dev,
 golang-github-coredhcp-coredhcp-dev,
 golang-github-d-tux-go-fstab-dev,
 golang-github-docker-distribution-dev,
 golang-github-docker-docker-dev,
 golang-github-fsnotify-fsnotify-dev,
 golang-github-go-git-go-git-dev,
 golang-github-google-nftables-dev (>= 0.2.0),
 golang-github-hashicorp-errwrap-dev,
 golang-github-hashicorp-go-multierror-dev,
 golang-github-hashicorp-hil-dev,
 golang-github-hetznercloud-hcloud-go-dev,
 golang-github-iancoleman-strcase-dev (>= 0.3.0),
 golang-github-insomniacslk-dhcp-dev,
 golang-github-libvirt-libvirt-go-dev,
 golang-github-libvirt-libvirt-go-xml-dev,
 golang-github-mdlayher-ethernet-dev,
 golang-github-mdlayher-raw-dev,
 golang-github-pborman-uuid-dev,
 golang-github-pin-tftp-dev,
 golang-github-pkg-errors-dev,
 golang-github-tredoe-osutil-dev,
 golang-github-urfave-cli-v2-dev,
 golang-github-yalue-merged-fs-dev,
 golang-go4-netipx-dev,
 golang-golang-x-tools,
 golang-google-grpc-dev,
 golang-gopkg-natefinch-lumberjack.v2-dev,
 golang-gopkg-src-d-go-git.v4-dev,
 golang-gopkg-yaml.v2-dev,
 golang-honnef-go-augeas-dev,
 golang-honnef-go-tools-dev,
 golang-opentelemetry-contrib-dev,
 graphviz,
 inotify-tools,
 libaugeas-dev,
 libpcap0.8-dev,
 libvirt-dev,
 nex,
 openstack-pkg-tools,
 packagekit,
 pkg-config,
 ragel,
 ruby-dev,
 time,
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/openstack-team/third-party/mgmt
Vcs-Git: https://salsa.debian.org/openstack-team/third-party/mgmt.git
Homepage: https://github.com/purpleidea/mgmt

Package: mgmt
Architecture: any
Depends:
 packagekit,
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 graphviz,
Description: next generation config management
 Mgmt is a real-time automation tool. It is familiar to existing configuration
 management software, but is drastically more powerful as it can allow you to
 build real-time, closed-loop feedback systems, in a very safe way, and with a
 surprisingly small amount of our mcl code. For example, the following code
 will ensure that your file server is set to read-only when it's friday.
 .
 It can run continuously, intermittently, or on-demand, and in the first case,
 it will guarantee that your system is always in the desired state for that
 instant! In this mode it can run as a decentralized cluster of agents across
 your network, each exchanging information with the others in real-time, to
 respond to your changing needs.
